package io.zipcoder;

import javax.swing.*;
import java.util.EmptyStackException;
import java.util.Scanner;
import java.util.Stack;

public class ParenChecker {


    private static final String OPEN = "([{";
    /**
     * Set of closing parenthesis characters, matches OPEN.
     */
    private static final String CLOSE = ")]}";


    public static boolean isBalanced(String expression) {
        // Create an empty stack.
        Stack<Character> s = new Stack<Character>();
        boolean balanced = true;
        try {
            int index = 0;
            while (balanced && index < expression.length()) {
                char nextCh = expression.charAt(index);
                if (isOpen(nextCh)) {
                    s.push(nextCh);
                } else if (isClose(nextCh)) {
                    char topCh = s.pop();
                    balanced =
                            OPEN.indexOf(topCh) == CLOSE.indexOf(nextCh);
                }
                index++;
            }
        } catch (EmptyStackException ex) {
            balanced = false;
        }
        return (balanced && s.empty());
    }



    private static boolean isOpen(char ch) {
        return OPEN.indexOf(ch) > -1;
    }
    private static boolean isClose(char ch) {
        return CLOSE.indexOf(ch) > -1;
    }

   /* public static void main(String args[]) {
       // String expression =// JOptionPane.showInputDialog(
        System.out.println   ( "Enter an expression containing parentheses");
        Scanner scan=new Scanner(System.in);
        String str=scan.nextLine();
        //System.out.println("" +    countingCharacter(str)) ;
        //System.out.println(str.length() )  ;

        if (ParenChecker.isBalanced(str)) {
           // JOptionPane.showMessageDialog(null, expression
             System.out .println( "parenchecker" + str  + " is balanced");

        } else {
            //JOptionPane.showMessageDialog(null, str
            System.out.println("parenchecker" +str  + " is not balanced");
        }
        System.exit(0);
    }*/
}